<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
* DOCman File Listing Content Plugin Helper
*
* @since 1.5
*/
abstract class DownloadQueueHelper
{

	public static function getDocsByUserAccess($documentIds)
	{
		if (empty($documentIds))
		{
			$rows = array();
			return $rows;
		}

		$fileLimitPerCategory = (int) 9999;
		$ordering = '`tbl`.' . 'title'; // $this->params->get('ordering', 'title');
		$direction = 'ASC'; // $this->params->get('orderingdir', 'DESC');
		//$inCategories = implode(',', DOCmanListHelper::array_keys_recursive($catIds));
		$now = JFactory::getDate()->toSql();

		$db = JFactory::getDbo();

		$query = $db->getQuery(true);

		$query->select('`c`.`title` AS `category_title` , `c`.`slug` AS `category_slug`');
		$query->select('CONCAT_WS(\'-\', `tbl`.`docman_document_id`, `tbl`.`slug`) AS `alias`');
		$query->select('`creator`.`name` AS `created_by_name`');
		$query->select('`creator`.`username` AS `created_by_username`');
		$query->select('`modifier`.`name` AS `modified_by_name`');
		$query->select('`locker`.`name` AS `locked_by_name`');
		$query->select('`viewlevel`.`title` AS `access_title`');
		$query->select('IF(`tbl`.`publish_on` = 0, `tbl`.`created_on`, `tbl`.`publish_on`) AS `publish_date`');
		$query->select('`tbl`.docman_document_id as id');
		$query->select('`tbl`.title');
		$query->select('`tbl`.slug');
		$query->select('`tbl`.docman_category_id as catid');
		$query->select('`tbl`.description');
		$query->select('`tbl`.image');
		$query->select('`tbl`.storage_type');
		$query->select('`tbl`.storage_path');
		$query->select('`tbl`.hits');
		$query->select('LOWER(substring_index(tbl.storage_path, \'.\', -1)) extension');
		$query->select('`tbl`.locked_on');
		$query->select('`tbl`.locked_by');
		$query->select('`tbl`.created_on');
		$query->select('`tbl`.created_by');
		$query->select('`tbl`.modified_on');
		$query->select('`tbl`.modified_by');
		$query->select('`tbl`.asset_id');

		$query->from('`#__docman_documents` AS `tbl`');
		$query->leftJoin('`#__docman_categories` AS `c` ON (`tbl`.`docman_category_id` = `c`.`docman_category_id`)');
		$query->leftJoin('`#__users` AS `creator` ON (`tbl`.`created_by` = `creator`.`id`)');
		$query->leftJoin('`#__users` AS `modifier` ON (`tbl`.`modified_by` = `modifier`.`id`)');
		$query->leftJoin('`#__users` AS `locker` ON (`tbl`.`locked_by` = `locker`.`id`)');

		$query->where('(`tbl`.`enabled` = 1 OR `tbl`.`created_by` = ' . (int) JFactory::getUser()->id .  ')');
		$query->where('`tbl`.`docman_document_id` IN  (' . $documentIds . ')');
		$query->where('(' . sprintf('(tbl.publish_on = 0 OR tbl.publish_on <= \'%s\') ', $now) . ' OR `tbl`.`created_by` = ' . (int) JFactory::getUser()->id .  ')');
		$query->where('(' . sprintf('(tbl.unpublish_on = 0 OR tbl.unpublish_on >= \'%s\') ', $now) . ' OR `tbl`.`created_by` = ' . (int) JFactory::getUser()->id .  ')');

		if (self::isDocman21())
		{
			$query->select('(CASE `tbl`.`access` WHEN 0 THEN COALESCE(`c`.`access`, 1) ELSE `tbl`.`access` END) AS `access`');
			$query->leftJoin('`#__viewlevels` AS `viewlevel` ON ((CASE `tbl`.`access` WHEN 0 THEN COALESCE(`c`.`access`, 1) ELSE `tbl`.`access` END) = `viewlevel`.`id`)');

			$userLevels = KObjectManager::getInstance()->getObject('com://admin/docman.model.documents')->getUserLevels(JFactory::getUser()->id);

			$access = JFactory::getUser()->getAuthorisedViewLevels();
			$user_access_clause = '';
			if ($access)
			{
				$access = array_merge($access, $userLevels);
				$user_access_clause = ' OR `tbl`.`created_by` = ' . (int) JFactory::getUser()->id . ' OR `c`.`created_by` = ' . (int) JFactory::getUser()->id;
			}

			$query->where('(' . sprintf('(CASE tbl.access WHEN 0 THEN COALESCE(c.access, 1) ELSE tbl.access END) IN (%s) ', implode(',', $access)) . $user_access_clause . ')');
		}
		else
		{
			$query->select('(CASE `tbl`.`access` WHEN -1 THEN COALESCE(`c`.`access`, 1) ELSE `tbl`.`access` END) AS `access`');
			$query->leftJoin('`#__viewlevels` AS `viewlevel` ON ((CASE `tbl`.`access` WHEN -1 THEN COALESCE(`c`.`access`, 1) ELSE `tbl`.`access` END) = `viewlevel`.`id`)');
			$query->where('(' . sprintf('(CASE tbl.access WHEN -1 THEN COALESCE(c.access, 1) ELSE tbl.access END) IN (%s) ', implode(',', JFactory::getUser()->getAuthorisedViewLevels())) . ' OR `tbl`.`created_by` = ' . (int) JFactory::getUser()->id . ')');
		}

		$query->order($ordering . ' ' . $direction);

		$db->setQuery($query);

		$rows = $db->loadObjectList();

		$groupedByCategory = array();
		$userIds = array();
		foreach($rows as &$row)
		{
			if ($row->storage_type === 'file')
			{
				//$row->filesize = DOCmanListHelper::getSize($row->storage_path, $pathToDOCmanFiles);
			}
			else
			{
				//$row->filesize = 'N/A';
			}

			// Add Itemid for each File:
			//$row->itemid = DOCmanListItemidHelper::findItemid($row);
		}

		return $rows;
	}

	public static function isDocman21()
	{
		$version = self::getDocmanVersion();
		return (version_compare($version, '2.1', '>='));
	}

	public static function getDocmanVersion()
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(true);

		$query->select('manifest_cache');
		$query->from($db->quoteName('#__extensions'));
		$query->where($db->quoteName('element') . ' = ' . $db->quote('com_docman'));

		$db->setQuery($query);

		$xmlManifestCache = $db->loadResult();

		// Convert the params to an object.
		if (is_string($xmlManifestCache))
		{
			$temp = new JRegistry;
			$temp->loadString($xmlManifestCache);
			$xmlManifestCache = $temp;
		}

		$docmanVersion = $xmlManifestCache->get('version');

		return $docmanVersion;
	}

	/**
	*
	* @desc This function selects every documents in a category
	*         by user access level
	* @param mixed $catid Integer or comma separated string of catids
	* @param int $ the category id
	* @param string $ the ordering query
	*/
	/*public static function getDocsByUserAccess($ids = 0, $ordering = '', $direction = '', $limit = '', $limitstart = 0)
	{
		global $_DOCMAN;

		$database = JFactory::getDBO();

		$user = $_DOCMAN->getUser();
		// get ordering
		$ordering = trim($ordering);
		if ($ordering == '')
			$ordering = $_DOCMAN->getCfg('default_order');

		switch ($ordering) {
			case 'name' : $ordering = 'd.dmname';
				break;
			case 'filename' : $ordering = 'd.dmfilename';
				break;
			case 'date' : $ordering = 'd.dmdate_published';
				break;
			case 'hits' : $ordering = 'd.dmcounter';
				break;
			default :
				$ordering = 'd.dmname';
		}
		// get direction
		$direction = (string) strtoupper(trim($direction));
		if ($direction == '') {
			$direction = $_DOCMAN->getCfg('default_order2');
		}
		if(!in_array($direction, array('ASC', 'DESC')) ) {
			$direction = 'ASC';
		}

		// preform query
		$query = "SELECT d.*, c.title AS cat_title FROM #__docman AS d"
			. "\n LEFT JOIN #__docman_categories AS c ON d.catid = c.id ";

		 if (!$user->userid)
		 {
			 if(!$_DOCMAN->getCfg('registered')) {
				 return array();
			 }

			$query .= "WHERE d.dmowner=" . _DM_PERMIT_EVERYONE
				 . "\n AND d.published=1 AND d.approved=1";

			   $query .= $ids ? "\n AND d.id IN ($ids) " : "";

		}
		else
		   {
			if ($user->isSpecial) {
				 $query .= $ids ? "\n WHERE d.id IN ($ids) " : "";
			} elseif ($user->canApprove()) {
				$query .= $ids ? "\n WHERE d.id IN ($ids) " : "";
			} elseif ($user->canPublish()) {
				 $query .= "WHERE d.approved=1";
				 $query .= $ids ? "\n AND d.id IN ($ids) " : "";
			} elseif ($user->userid) {
				$query .= "WHERE d.published=1 AND d.approved=1"
					 . "\n AND (d.dmowner=" . $user->userid
					  . "\n OR d.dmmantainedby=" . $user->userid
					  . "\n OR d.dmowner=" . _DM_PERMIT_EVERYONE
					  . "\n OR d.dmowner=" . _DM_PERMIT_REGISTERED;
					if ($user->groupsIn != '0,0') {
					$query .= "\n OR d.dmowner IN (" . $user->groupsIn . ")";
					$query .= "\n OR d.dmmantainedby IN (" . $user->groupsIn . ")";
				   }
				if ($_DOCMAN->getCfg('author_can') != _DM_AUTHOR_NONE) {
					$query .= "\n OR d.dmsubmitedby = " . $user->userid;
				}
				$query .= ")";

				$query .= $ids ? "\n AND d.id IN ($ids) " : "";
			}
		 }

		//$query .= "\n ORDER BY $ordering $direction";
		$database->setQuery($query);

		return $database->loadObjectList();
	}*/
}