<?php
/**
 * @package		Joomla.Site
 * @subpackage	mod_articles_categories
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

// usort() comparison function for Person objects
function modArtCats25SortByTitle($a, $b) {
    return $a->title == $b->title ? 0 : ( $a->title > $b->title ) ? 1 : -1;
}

abstract class modDownloadQueueHelper
{
	public static function getList(&$params, &$module = null)
	{
        $configItems = KObjectManager::getInstance()->getObject('com://admin/docman.model.configs')->fetch();
        $pathToDOCmanFiles = JPATH_ROOT . '/' . $configItems->document_path . '/';
        require_once JPATH_PLUGINS.'/content/docmanlist/docmanlist/classes/helper.php';


		$session = JFactory::getSession();
		$queue = $session->get('downloadqueue.queue', array());

        // Initialize variable:
        $attachments = array();

        if (!empty($queue))
        {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);

            $query->select('docman_document_id id, title, storage_path, storage_type, storage_path dmurl, description');
            $query->select('LOWER(substring_index(storage_path, \'.\', -1)) filetype '); // extension
            $query->from('#__docman_documents');
            $query->where('docman_document_id IN (' . implode(',', $queue) . ')');

            if ($params->get('show_docman_filename', 0))
            {
                $query->order('title ASC');
            }
            else
            {
                //$query->order('dmfilename ASC');
            }


            $db->setQuery($query);
            $attachments = (array) $db->loadObjectList();

            // For creating the Image Icons:
            jimport('joomla.filesystem.folder');
            $availableFileTypes = JFolder::files(JPATH_ROOT . '/plugins/content/docmanlist/docmanlist/assets/images/', '.png');
            $pathToIconDirectory = JURI::root(true) . '/plugins/content/docmanlist/docmanlist/assets/images/';

            foreach($attachments as $attachment)
            {
                //$attachment->file_size = self::getSize($attachment->dmfilename);
                //$attachment->extension = JString::strtolower(JString::substr(strrchr($attachment->dmfilename, '.'), 1));

                if ($attachment->storage_type === 'file')
                {
                    $attachment->filesize = DOCmanListHelper::getSize($attachment->storage_path, $pathToDOCmanFiles);
                }
                else
                {
                    $attachment->filesize = 'N/A';
                }

                if (in_array($attachment->filetype . '.png', $availableFileTypes)) {
                    $attachment->icon = $pathToIconDirectory . $attachment->filetype . '.png';
                } else {
                    $attachment->icon = $pathToIconDirectory . 'generic.png';
                }
            }
        }


		return $attachments;
	}

    public static function queueAjax()
    {
        $id = JRequest::getInt('id', 0);

        $session = JFactory::getSession();

        $queue = $session->get('downloadqueue.queue', array());

        if ($id > 0)
        {
            $queue[] = $id;
            $queue = array_unique($queue);
            $session->set('downloadqueue.queue', $queue);
            echo "Added $id";
        }

        ob_end_clean();
        self::renderHtml();
        die();
    }

    public static function queueMultipleAjax()
    {
        $ids = JRequest::getVar('ids', '');

        if (!empty($ids))
        {
            $ids = explode(',', $ids);

            JArrayHelper::toInteger($ids);
        }

        $session = JFactory::getSession();

        $queue = $session->get('downloadqueue.queue', array());

        if (!empty($ids))
        {
            foreach($ids as $id)
            {
                if ($id > 0)
                {
                    $queue[] = $id;
                    $queue = array_unique($queue);
                    $session->set('downloadqueue.queue', $queue);
                    echo "Added $id";
                }
            }
        }

        ob_end_clean();
        self::renderHtml();
        die();
    }

    public static function clearAjax()
    {
        $id = JRequest::getInt('id', 0);

        $session = JFactory::getSession();

        if ($id > 0)
        {
            $queue = $session->get('downloadqueue.queue', array());

            $key = array_search($id, $queue);

            if ($key !== false)
            {
                unset($queue[$key]);
            }

            $session->set('downloadqueue.queue', $queue);
        }
        else
        {
            $session->set('downloadqueue.queue', array());
        }

        ob_end_clean();
        self::renderHtml();
        die();
    }

    public static function clearMultipleAjax()
    {
        $ids = JRequest::getVar('ids', '');

        if (!empty($ids))
        {
            $ids = explode(',', $ids);

            JArrayHelper::toInteger($ids);
        }

        $session = JFactory::getSession();

        $queue = $session->get('downloadqueue.queue', array());

        if (!empty($ids))
        {
            foreach($ids as $id)
            {
                if ($id > 0)
                {

                    $key = array_search($id, $queue);

                    if ($key !== false)
                    {
                        unset($queue[$key]);
                    }

                    $session->set('downloadqueue.queue', $queue);
                }
            }
        }

        ob_end_clean();
        self::renderHtml();
        die();
    }

    public static function renderHtml()
    {
        $module = JModuleHelper::getModule('mod_downloadqueue');
        if (empty($module->params))
        {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('params');
            $query->from('#__modules');
            $query->where('module = ' . $db->quote('mod_downloadqueue'));

            $db->setQuery($query);
            $module->params = (string) $db->loadResult();
        }
        $html = JModuleHelper::renderModule($module);

        $html = str_replace('<div id="downloadqueue">', '', $html);
        $html = substr_replace($html, '', -6, 6);

        //$html .= '<script src="media/com_downloadqueue/js/mod_downloadqueue_dynamic.js" type="text/javascript"></script>';
        echo $html;
    }

    public static function generateAjax()
    {
        $configItems = KObjectManager::getInstance()->getObject('com://admin/docman.model.configs')->fetch();
        $pathToDOCmanFiles = JPATH_ROOT . '/' . $configItems->document_path . '/';
        require_once JPATH_PLUGINS.'/content/docmanlist/docmanlist/classes/helper.php';

        $session = JFactory::getSession();
        $queue = $session->get('downloadqueue.queue', array());

        if (!empty($queue))
        {
            require_once dirname(__FILE__) . '/classes/helper.php';
            $documentsList = implode(',', $queue);
            $attachments = DownloadQueueHelper::getDocsByUserAccess($documentsList);

            $ids = array();
            foreach($attachments as $attachment)
            {
                $attachment->path = $pathToDOCmanFiles.$attachment->storage_path;
                $ids[] = $attachment->id;
            }

            sort($ids, SORT_NUMERIC);
            $lastModifiedTimes = array();
            foreach($attachments as $attachment)
            {
                $lastModifiedTimes[$attachment->id] = filemtime($attachment->path);
            }

            $key = '';
            foreach($ids as $id)
            {
                $key .= $id . ':' . $lastModifiedTimes[$id];
            }

            ob_end_clean();

            require_once dirname(__FILE__) . '/classes/zip.php';

            //$dateString = JHtml::date('now', 'Y-m-d_H_i_s');
            jimport('joomla.filesystem.folder');
            jimport('joomla.filesystem.file');

            $archivePath = JPATH_SITE . '/cache/mod_downloadqueue/';
            if (JFolder::create($archivePath))
            {
                $index = $archivePath . 'index.html';
                if (!JFile::exists($index)) {
                    $indexString = "<html>\n<body>\n</body>\n</html>";
                    !JFile::write($index, $indexString);
                }

                $archiveName = 'documents_' . md5($key) . '.zip';

                if (!JFile::exists($archivePath . $archiveName))
                {
                    set_time_limit(0);

                    $zip = new Zip();
                    $zip->setZipFile($archivePath . $archiveName);

                    $filenames = array();
                    foreach($attachments as $attachment)
                    {
                        if ($stream = fopen($attachment->path, 'r')) {
                            if (isset($filenames[$attachment->slug]))
                            {
                                $filenames[$attachment->slug] += 1;
                                $fileInfo = pathinfo($attachment->path);
                                $zip->addFile($stream, $fileInfo['filename'] . '_' . $filenames[$attachment->slug] . '.' . $fileInfo['extension']);
                            }
                            else
                            {
                                $fileInfo = pathinfo($attachment->path);
                                $zip->addFile($stream, $attachment->slug . '.' . $fileInfo['extension']);
                                $filenames[$attachment->slug] = 1;
                            }

                            fclose($stream);

                        }

                    }

                    $zip->finalize();
                    echo 'Created';
                }
                else
                {
                    echo 'Exists';
                }
            }
        }

        JFactory::getApplication()->close();
    }

    public static function downloadAjax()
    {
        $configItems = KObjectManager::getInstance()->getObject('com://admin/docman.model.configs')->fetch();
        $pathToDOCmanFiles = JPATH_ROOT . '/' . $configItems->document_path . '/';

        $session = JFactory::getSession();
        $queue = $session->get('downloadqueue.queue', array());

        if (!empty($queue))
        {
            require_once dirname(__FILE__) . '/classes/helper.php';
            $documentsList = implode(',', $queue);
            $attachments = DownloadQueueHelper::getDocsByUserAccess($documentsList);

            $ids = array();
            foreach($attachments as $attachment)
            {
                $attachment->path = $pathToDOCmanFiles.$attachment->storage_path;
                $ids[] = $attachment->id;
            }

            sort($ids, SORT_NUMERIC);
            $lastModifiedTimes = array();
            foreach($attachments as $attachment)
            {
                $lastModifiedTimes[$attachment->id] = filemtime($attachment->path);
            }

            $key = '';
            foreach($ids as $id)
            {
                $key .= $id . ':' . $lastModifiedTimes[$id];
            }

            ob_end_clean();

            //$dateString = JHtml::date('now', 'Y-m-d_H_i_s');
            $archivePath = JPATH_SITE . '/cache/mod_downloadqueue/';
            $archiveName = 'documents_' . md5($key) . '.zip';
            $contentType = "application/zip";

            jimport('joomla.filesystem.folder');
            jimport('joomla.filesystem.file');

            if (JFile::exists($archivePath . $archiveName))
            {
                $archiveSize = filesize($archivePath . $archiveName);

                set_time_limit(0);

                if (!headers_sent($headerFile, $headerLine) or die("<p><strong>Error:</strong> Unable to send file $archiveName. HTML Headers have already been sent from <strong>$headerFile</strong> in line <strong>$headerLine</strong></p>")) {
                    if ((ob_get_contents() === FALSE || ob_get_contents() == '') or die("\n<p><strong>Error:</strong> Unable to send file <strong>$archiveName.epub</strong>. Output buffer contains the following text (typically warnings or errors):<br>" . ob_get_contents() . "</p>")) {
                        if (ini_get('zlib.output_compression')) {
                            ini_set('zlib.output_compression', 'Off');
                        }

                        header('Pragma: public');
                        header("Last-Modified: " . gmdate("D, d M Y H:i:s T"));
                        header("Expires: 0");
                        header("Accept-Ranges: bytes");
                        header("Connection: close");
                        header("Content-Type: " . $contentType);
                        header("Content-Length: " . $archiveSize);
                        header('Content-Disposition: attachment; filename="' . $archiveName . '";' );
                        header("Content-Transfer-Encoding: binary");
                        flush();
                    }
                }

                if($archiveStream = fopen($archivePath . $archiveName, 'rb')){
                    while( (!feof($archiveStream)) && (connection_status()==0) ){
                        print(fread($archiveStream, 1024*8));
                        flush();
                    }
                    fclose($archiveStream);
                }
            }

            JFactory::getApplication()->close();
        }
    }
}
